﻿<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.inscription.name`)" />
        <BackLinkTitle :title="t(`routes.inscription.name`)" />
        <Card>
            <MemberForm :waitingMember="waitingMember" @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>



<script lang="ts" setup>
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import Card from "@/components/layout/Card.vue";
    import { useI18n } from "vue3-i18n";
    import { Member } from "@/types/entities/member";
    import MemberForm from "@/components/member/MemberForm.vue"
    import { notifyError, notifySuccess } from "@/notify";
    import { useMemberService, useWaitingMemberService } from "@/inversify.config"
    import { useRouter } from "vue-router";
    import { ICreateMemberRequest } from "../../types/requests/createMemberRequest";
    import { WaitingMember } from "../../types/entities/waitingMember";
    import { ref } from "vue";
    import { Lot } from "../../types";

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        id: string
    }>();

    const { t } = useI18n()
    const router = useRouter();
    const memberService = useMemberService();
    const waitingMemberService = useWaitingMemberService();
    const waitingMember = ref<WaitingMember>(await waitingMemberService.getWaitingMemberById(props.id));

    async function handleSubmit(waitingMember: WaitingMember, lot: Lot) {
        console.log({ waitingMember, lot });
        let password = "JardinEntente123!";
        let memberReq = {
            firstName: waitingMember.firstName,
            lastName: waitingMember.lastName,
            email: waitingMember.email,
            apartment: waitingMember.appNb,
            street: waitingMember.adress,
            city: "Quebec",
            zipCode: waitingMember.postalCode,
            phoneNumber: waitingMember.phoneNumber,
            password: password,
            lot: lot
        };
        console.log({ memberReq });
        let succeededOrNotResponse = await memberService.createMember(memberReq as ICreateMemberRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.user.add.success'));
            let succeededOrNotResponseDeleteWaitingMember = await waitingMemberService.deleteWaitingMember(props.id);
            if (succeededOrNotResponseDeleteWaitingMember && succeededOrNotResponseDeleteWaitingMember.succeeded) {
                setTimeout(() => router.back(), 1500);
            } else {
                notifyError(t('validation.waitingMember.delete.errorOccured'));
            } 
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.user.add');
            if (errorMessages.length == 0)
                notifyError(t('validation.user.add.errorOccured'));
            else
                notifyError(errorMessages[0])
        }

    }
</script>
